
package com.picfun.scope;

import android.app.Activity;
import android.os.Bundle;
import android.content.Context;
import android.content.Intent;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.hardware.usb.UsbConstants;
import android.hardware.usb.UsbDevice;
import android.hardware.usb.UsbDeviceConnection;
import android.hardware.usb.UsbEndpoint;
import android.hardware.usb.UsbInterface;
import android.hardware.usb.UsbManager;
import android.view.View;
import android.view.Window;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.view.Gravity;
import android.os.Handler;

public class OsscilloHost extends Activity implements Runnable {
	// USB関連変数定義
	private UsbManager mUsbManager;    
	private UsbDevice mDevice;    
	private UsbDeviceConnection mConnection;    
	private UsbEndpoint mEndpointOut;
	private UsbEndpoint mEndpointIn;
	// バッファ、一般変数定義
	private byte[] message = new byte[64]; 	
	private byte[] buffer = new byte[64];
	private int[] DataBuffer = new int[2048];
	private int Flag, TrigLevel, Index, Hsync;
	private int result, i, BlockCounter, State, temp;
	private final Handler handler = new Handler();
	// クラス変数、定数の宣言
	private final static int WC = LinearLayout.LayoutParams.WRAP_CONTENT;
	private static Button[] sample = new Button[6];	
	private static TextView text, text1, text2, text3, text10;
	private static MyView graph;
	// USB control commands    
	private static final int COMMAND_REQUEST = 0x31;
	private static final int COMMAND_EXTEND  = 0x32;

    /******* 最初に実行する関数 ********/
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);    
        /*** レイアウト定義　*******/     
        LinearLayout layout = new LinearLayout(this);
        layout.setOrientation(LinearLayout.HORIZONTAL);
        setContentView(layout); 
        	// サブレイアウト
        	LinearLayout layout2 = new LinearLayout(this);
            layout2.setOrientation(LinearLayout.VERTICAL);
            layout2.setGravity(Gravity.LEFT); 
             	// 見出しテキスト表示             
    	        text = new TextView(this);
    	        text.setLayoutParams(new LinearLayout.LayoutParams(230,WC));
    	        text.setTextSize(30f);
       	        text.setTextColor(Color.MAGENTA);    	        
    	        text.setText("オシロスコープ");
    	        layout2.addView(text);
    	    	// サンプリング周期設定タイトル
    	    	LinearLayout.LayoutParams params1 = new LinearLayout.LayoutParams(230, WC);
      	    	params1.setMargins(10,30, 0,0);   	        
    	    	text10 = new TextView(this);
    	    	text10.setTextSize(20f);
      	        text10.setLayoutParams(params1);
      	        text10.setText("サンプリング周期選択");
      	        layout2.addView(text10); 
       	    	// サンプリング周期設定ボタン生成    	    	
    	    	LinearLayout.LayoutParams params2 = new LinearLayout.LayoutParams(150, WC);
      	    	params2.setMargins(20,10, 0,0);
      	    	for(i=0; i<6; i++){
        	    	sample[i] = new Button(this);
        	    	sample[i].setBackgroundColor(Color.BLUE);
        	    	sample[i].setTextSize(20f);
        	    	sample[i].setLayoutParams(params2);
        	    	layout2.addView(sample[i]);     	    		
      	    	}
      	    	sample[0].setText("20μs / Div");	
      	    	sample[1].setText("50μs / Div");
      	    	sample[2].setText("200μs / Div");
      	    	sample[3].setText("500μs / Div");
      	    	sample[4].setText("2ms / Div");
      	    	sample[5].setText("5ms / Div");
    	    	// デバッグ用メッセージボックス生成
    	    	LinearLayout.LayoutParams params3 = new LinearLayout.LayoutParams(230, WC);
      	    	params3.setMargins(5, 150, 0,0);     	    	
    	    	LinearLayout.LayoutParams params4 = new LinearLayout.LayoutParams(230, WC);
      	    	params4.setMargins(5, 5, 0,0);	
    	    	text1 = new TextView(this);
      	        text1.setLayoutParams(params3);
      	        text1.setTextSize(16f);
      	        text1.setText("デバッグメッセージ No1 ");
      	        layout2.addView(text1);
      	        
      	        text2 = new TextView(this);
             	text2.setTextSize(16f);
      	        text2.setLayoutParams(params4);
    	        text2.setText("デバッグメッセージ No2");
    	        layout2.addView(text2); 
      	        
    	        text3 = new TextView(this);
    	        text3.setTextSize(16f);
    	        text3.setLayoutParams(params4);
    	        text3.setText("デバッグメッセージ No3");
    	        layout2.addView(text3); 	        
    	layout.addView(layout2);
    	// グラフ描画
    	graph = new MyView(this);
        layout.addView(graph); 
        // ボタンイベントリスナ生成
        for(i=0; i<6; i++)
        	sample[i].setOnClickListener((OnClickListener) new syncScope());	       
        // USBマネージャオブジェクト生成
		mUsbManager = (UsbManager)getSystemService(Context.USB_SERVICE);	
		// 初期表示用正弦波データ格納
		for(i=0; i<1024; i++)
			DataBuffer[i] = (int)(350*(Math.sin(Math.toRadians((double)i))));
    }
    
	/**** アプリ遷移時イベント処理 *****/
	@Override    
	public void onResume() {   
		super.onResume();        
		Intent intent = getIntent();
 		String action = intent.getAction(); 	
		UsbDevice device = (UsbDevice)intent.getParcelableExtra(UsbManager.EXTRA_DEVICE); 
		if (UsbManager.ACTION_USB_DEVICE_ATTACHED.equals(action)) {
			text1.setTextColor(Color.GREEN);			
			text1.setText("アプリケーション再起動");
			setDevice(device); 
		} 
		else if (UsbManager.ACTION_USB_DEVICE_DETACHED.equals(action)) {      
			if (mDevice != null && mDevice.equals(device)) {          
				setDevice(null);
				mConnection.close();
				text1.setTextColor(Color.YELLOW);				
				text1.setText("デバイス　デタッチで終了");
			}    
		}
	}  
	
	/**** 終了時クローズ ***************/
	@Override    
	public void onDestroy() {    
		super.onDestroy();
	}   
	
	/***** USBデバイスEnumeration ******/
	private void setDevice(UsbDevice device) { 
		// デバイスインターフェース検出
		if (device.getInterfaceCount() != 1) { 
			text3.setText("インターフェース発見できない");			
			return;  
		}        
		UsbInterface intf = device.getInterface(0);        
		// エンドポイントの検出       
		if (intf.getEndpointCount() < 1) { 
			text3.setText("エンドポイント検出できない");
			return;    
		} 
		text2.setText("検出エンドポイント数 = " + intf.getEndpointCount());		
		// OUTエンドポイントの確認        
		UsbEndpoint epout = intf.getEndpoint(0); 
		if (epout.getType() != UsbConstants.USB_ENDPOINT_XFER_BULK) { 
			text3.setText("OUTエンドポイントがバルクタイプでない");
			return;   
		}
		// INエンドポイントの確認
		UsbEndpoint epin = intf.getEndpoint(1);
		if (epin.getType() != UsbConstants.USB_ENDPOINT_XFER_BULK) { 
			text3.setText("INエンドポイントがバルクタイプでない");
			return;   
		}
		// デバイス定数代入
		mDevice = device;        
		mEndpointOut = epout;
		mEndpointIn = epin;
		// 接続許可確認
		if (mDevice != null) {       
			UsbDeviceConnection connection = mUsbManager.openDevice(mDevice);           
			if (connection != null && connection.claimInterface(intf, true)) {          
				mConnection = connection;
				text2.setTextColor(Color.GREEN);		
				text2.setText("USBデバイス接続正常完了");				
				Flag = 1;								// スレッドループ用フラグ
				State = 1;								// 受信処理ステート初期化
				BlockCounter = 0;						// 64バイトブロックカウンタリセット
				Hsync = 2;								// サンプリング周期を200usecとする
				TrigLevel = 0;							// トリガレベルは0Vとする				
				Thread thread = new Thread(this); 		// USB受信スレッド起動               
				thread.start();         
			}
			else {         
				mConnection = null;
				text3.setTextColor(Color.RED);
				text3.setText("USBデバイス接続失敗");
			}    
		}
	}  
    
    /****  ボタンイベントクラス *******/
    class syncScope implements OnClickListener{
    	public void onClick(View v){
    		for(i=0; i<6; i++){
    			if(v == sample[i])
    				Hsync = i;
    		}
    	}    		
    }  
    	
	/**** コマンド送信メソッド ********/
	private void sendCommand(int control) { 
		synchronized (this) { 
			if (mConnection != null) {          
				switch(control){
					case COMMAND_REQUEST:
						message[0] = COMMAND_REQUEST;
						break;
					case COMMAND_EXTEND:
						message[0] = COMMAND_EXTEND;
						break;
					default: break;
				}
				// エンドポイントでコマンド送信	常に64バイト送信				
				mConnection.bulkTransfer(mEndpointOut, message, 64, 0);				
			}
		}
	}	
	
	/**** USBデータ受信スレッド 一定周期で繰り返し ***/
	@Override    
	public void run() { 
		while (Flag == 1) {
			switch(State){
				case 1:			// 状態、計測要求コマンド送信
					message[1] = (byte)Hsync;						// サンプリング周期セット					
					sendCommand(COMMAND_REQUEST);					// 計測開始要求
					/* 折り返し受信実行　*/
					result = mConnection.bulkTransfer(mEndpointIn, buffer, 64, 0);
					if((result > 0)&&(buffer[0] == 'O')&&(buffer[1] == 'K')){
						State = 2;
						BlockCounter = 0;
						// メッセージ出力
						handler.post(new Runnable(){
							public void run(){
								text3.setTextColor(Color.GREEN);
								text3.setText("通信再開"); 			
						}	});						
					}
					/* 正常応答でなければデバイスが切り離されたとしてスレッド終了	*/	
					else{
						mConnection.close();
						Flag = 0;									// ループフラグクリア
						// メッセージ出力
						handler.post(new Runnable(){
							public void run(){
								text3.setTextColor(Color.RED);
								text3.setText("デバイスが切り離されました２"); 			
						}	});						
					}
					// データ計測時間確保待ち
					try{
						Thread.sleep(500);							// 0.5秒お休み
					}catch(InterruptedException e){ }
					break;
				case 2:			// データ受信繰り返し
					sendCommand(COMMAND_EXTEND);					// 次のデータ送信要求
					// 折り返しデータ受信実行　常に64バイト受信
					result = mConnection.bulkTransfer(mEndpointIn, buffer, 64, 0);
					// 正常受信なら受信データ処理実行
					if(result > 0){
						// データのバッファ格納、 Byteからintに変換
						for(i=0; i<64; i+=2){
							temp = (buffer[i] & 0x7F) + buffer[i+1]*256;
							if((buffer[i]&0x80) != 0)
								temp += 128;
							DataBuffer[BlockCounter*32+i/2] = (temp - 512)*3/2;
						}
						BlockCounter++;								// 64バイトブロックカウンタ更新
						if(BlockCounter >= 64){						// 64ブロック終了か？
							BlockCounter = 0;						// 最初に戻す
							State = 3;								// 次のステートに進む
						}
					}
					/* 正常受信できなければスレッド終了	*/	
					else{
						mConnection.close();
						Flag = 0;				// ループフラグクリア
						// メッセージ出力
						handler.post(new Runnable(){
							public void run(){
								text3.setTextColor(Color.RED);
								text3.setText("デバイスが切り離されました１"); 			
						}	});							
					}
					break;
				case 3:			// データ表示
					handler.post(new Runnable(){
						public void run(){			
							graph.invalidate();						// データグラフの再表示	
					}	});
					State = 1;										// ステートを最初に戻す
					break;
				default:	State = 1;	break;
			}
		}
	}

	/**** グラフを描画するクラス   ****/
	class MyView extends View{
		// Viewの初期化
		public MyView(Context context){
			super(context);
		}
		// グラフ描画実行メソッド
		public void onDraw(Canvas canvas)	{
	 		super.onDraw(canvas);
	 		Paint set_paint = new Paint();	 		//背景色の設定
			canvas.drawColor(Color.BLACK); 			
			set_paint.setColor(Color.BLUE);			// 座標の表示 青色で表示
			set_paint.setStrokeWidth(1);
			for(i=0; i<=10; i++)					// 縦軸の表示　10本
				canvas.drawLine(30+i*100, 10, 30+i*100, 710, set_paint);
			for(i=0; i<7; i++)						// 横軸の表示　7本　中央を0とする
				canvas.drawLine(30, 60+i*100, 1030, 60+i*100, set_paint);
			// X軸とY軸の0ライン白色で描画
			set_paint.setColor(Color.WHITE);
			canvas.drawLine(30, 360, 1030, 360, set_paint);
			set_paint.setStrokeWidth(2);   		
			canvas.drawLine(30, 10, 30, 710, set_paint);
			canvas.drawLine(1030, 10, 1030, 710, set_paint);
			canvas.drawLine(30, 10, 1030, 10 ,set_paint);
			canvas.drawLine(30, 710, 1030, 710, set_paint);			
			// 軸目盛の表示			
			set_paint.setAntiAlias(true);
			set_paint.setTextSize(20f);
			set_paint.setColor(Color.WHITE);
			for(i=0; i<=10; i++)					// X座標目盛
	    		canvas.drawText(Integer.toString(i), 26+i*100, 735, set_paint);   			
			for(i=-3; i<=3; i++)					// Y座標目盛
				canvas.drawText(Integer.toString(i), 8, 368-i*100, set_paint);
			// 水平軸時間表示
			set_paint.setColor(Color.CYAN);
			switch(Hsync){
				case 0:
					canvas.drawText("20usec/Div", 350, 690, set_paint);
					break;			
				case 1:
					canvas.drawText("50usec/Div", 350, 690, set_paint);
					break;					
				case 2:
					canvas.drawText("200usec/Div", 350, 690, set_paint);
					break;
				case 3:
					canvas.drawText("500usec/Div", 350, 690, set_paint);
					break;
				case 4:
					canvas.drawText("2msec/Div", 350, 690, set_paint);
					break;
				case 5:
					canvas.drawText("5msec/Div", 350, 690, set_paint);
					break;
				default:break;
			}
			// トリガ
			Index = 0;
			for(i=1; i<1000; i++){
				if((DataBuffer[i-1] <= TrigLevel) && (DataBuffer[i] > TrigLevel)
						             && (DataBuffer[i+1]> DataBuffer[i])){
					Index = i-1;
					break;
				}
			}
			// 実際のグラフの表示
 			set_paint.setColor(Color.GREEN);
 			switch(Hsync){
 				case 0:
		 			for(i=0; i<100; i++)
		 				canvas.drawLine(10*i+30, 360-DataBuffer[Index+i], 10*(i+1)+30,
		 						             360-DataBuffer[Index+i+1], set_paint);
		 			break;
 				case 1:
		 			for(i=0; i<250; i++)
		 				canvas.drawLine(4*i+30, 360-DataBuffer[Index+i], 4*(i+1)+30,
		 						             360-DataBuffer[Index+i+1], set_paint);
		 			break;
	 			case 2:
	 			case 3:
	 			case 4:
	 			case 5:
		 			for(i=0; i<1000; i++)
		 				canvas.drawLine(i+30, 360-DataBuffer[Index+i], (i+1)+30,
		 						             360-DataBuffer[Index+i+1], set_paint);
		 			break;
		 		default:
		 			break;
 			}
		}
	}
}


